Loading...
Searching...
No Matches
BALL::VIEW::DockingController Class Reference
Visualisation » Modular Widgets

`#include <BALL/VIEW/WIDGETS/dockingController.h>`

Inheritance diagram for BALL::VIEW::DockingController:

## Public Types

Enumerations
enum | Algorithm { GEOMETRIC_FIT = 1 }
enum | ScoringFunction { DEFAULT = 0 , AMBER_FF , MMFF94_FF , SELECTED_FF , RANDOM }
Public Types inherited from BALL::Embeddable
typedef std::vector< Embeddable * > | EmbeddableVector

## Public Member Functions

Constructors, Destructors, and Assignment
| DockingController (QWidget *parent=0, const char *name=0)
| Default Constructor.
virtual | ~DockingController ()
| Destructor.
const DockingController & | operator= (const DockingController &dock_controller)
| Assignment operator.
Public Member Functions inherited from BALL::VIEW::ModularWidget
| ModularWidget (const char *name="<ModularWidget>")
| ModularWidget (const ModularWidget &widget)
virtual | ~ModularWidget ()
virtual void | destroy ()
virtual void | clear ()
QAction * | insertMenuEntry (Position parent_id, const QString &name, const QObject *receiver=0, const char *slot=0, const String &description="", QKeySequence accel=QKeySequence(), const QString &menu_hint=QString(""), UIOperationMode::OperationMode minimal_mode=UIOperationMode::MODE_ALL)
BALL_DEPRECATED void | setMenuHelp (QAction *, const String &)
virtual BALL_DEPRECATED void | registerForHelpSystem (const QObject *, const String &)
virtual void | addToolBarEntries (QToolBar *main_tb)
void | setIcon (QAction *action, const String &filename, bool add_to_main_toolbar=true)
virtual void | initializePreferencesTab (Preferences &preferences)
virtual void | finalizePreferencesTab (Preferences &preferences)
virtual void | applyPreferences ()
bool | lockComposites ()
bool | unlockComposites ()
| Unlock the Composites.
MainControl * | getMainControl () const
virtual void | setStatusbarText (const String &text, bool important=false)
virtual void | setStatusbarText (const QString &text, bool important=false)
String | getWorkingDir ()
| Implemented for convenience.
void | setWorkingDir (const String &dir)
| Implemented for convenience.
FragmentDB & | getFragmentDB () const
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
void | setWorkingDirFromFilename_ (String filename)
virtual BALL_DEPRECATED void | showHelp (const String &)
virtual void | finalizeWidget (MainControl &main_control)
virtual bool | canHandle (const String &) const
virtual bool | openFile (const String &)
Public Member Functions inherited from BALL::Embeddable
| Embeddable (const String &identifier="<Embeddable>")
| Embeddable (const Embeddable &embeddable)
virtual | ~Embeddable ()
void | setIdentifier (const String &identifier)
const String & | getIdentifier () const
void | unregisterThis ()
virtual void | registerThis ()
Public Member Functions inherited from BALL::VIEW::ConnectionObject
| ConnectionObject ()
virtual | ~ConnectionObject ()
void | registerConnectionObject (ConnectionObject &object)
void | unregisterConnectionObject (ConnectionObject &object)
bool | isConnectionObjectRegistered (const ConnectionObject &object)
ConnectionObject * | getParent () const
ConnectionObject * | getRoot ()
virtual bool | isValid () const

## ModularWidget methods

virtual void | initializeWidget (MainControl &main_control)
virtual void | fetchPreferences (INIFile &file)
virtual void | writePreferences (INIFile &file)
virtual void | checkMenu (MainControl &main_control)
virtual void | onNotify (Message *message)
virtual void | runDocking (bool is_redock)
DockDialog & | getDockDialog ()
| Get docking dialog.
virtual EnergeticEvaluation * | createEvaluationMethod (Index method)
void | startDocking ()
bool | runScoring_ (ConformationSet *conformation_set)

## Additional Inherited Members

static void | registerWidget (ModularWidget *mwidget)
void | notify_ (Message *message)
void | notify_ (Message &message)
void | onNotify_ (Message *message)
static void | registerInstance_ (const std::type_info &type, const Embeddable *instance)
static void | unregisterInstance_ (const Embeddable *instance)
static Size | countInstances_ (const std::type_info &type)
static Embeddable * | getInstance_ (const std::type_info &type, Position index)
static Embeddable * | getInstance_ (const std::type_info &type, const String &identifier)
QAction * | window_menu_entry_
bool | show_window_enty_
bool | default_visible_
QList< QAction * > | main_toolbar_actions_

## Detailed Description

Class for docking two systems. It is responsible to show the docking dialog and start a docking caluclation with the options of the dialog. If BALLView was compiled with multithreading support it simultaneously shows the progress dialog. Finally it shows the result dialog.

Definition at line 37 of file dockingController.h.

## Member Enumeration Documentation

## Algorithm

enum BALL::VIEW::DockingController::Algorithm

Enumeration which contains the docking algorithms. The numbering corresponds to the order in the combobox of dock_dialog_ . If you want to add a new docking algorithm extend enumeration (0 corresponds to <select> item in ComboBox)

Enumerator
GEOMETRIC_FIT |

Definition at line 59 of file dockingController.h.

## ScoringFunction

enum BALL::VIEW::DockingController::ScoringFunction

Enumeration which contains the scoring functions. The numbering corresponds to the order in the combobox of dock_dialog_ . If you want to add a new scoring function extend enumeration

Enumerator
DEFAULT |
AMBER_FF |
MMFF94_FF |
SELECTED_FF |
RANDOM |

Definition at line 69 of file dockingController.h.

## Constructor & Destructor Documentation

## DockingController()

BALL::VIEW::DockingController::DockingController | ( | QWidget * | parent = 0,
|  | const char * | name = 0 )

Default Constructor.

## ~DockingController()

virtual BALL::VIEW::DockingController::~DockingController | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## checkMenu()

virtual void BALL::VIEW::DockingController::checkMenu | ( | MainControl & | main_control | ) |

virtual

Updates the state of menu entry Docking in the popup menu Molecular Mechanics . Enables the menu entry if more than two composites are loaded. Disables the menu entry if less composites are loaded or if a simulation / calculation is running.

Reimplemented from BALL::VIEW::ModularWidget.

## createEvaluationMethod()

virtual EnergeticEvaluation * BALL::VIEW::DockingController::createEvaluationMethod | ( | Index | method | ) |

virtual

## fetchPreferences()

virtual void BALL::VIEW::DockingController::fetchPreferences | ( | INIFile & | file | ) |

virtual

Fetches the preferences from the INIFile. Calls DockDialog::fetchPreferences . This method will be called inside the method MainControl::show .

See also
  writePreferences

Reimplemented from BALL::VIEW::ModularWidget.

## getDockDialog()

DockDialog & BALL::VIEW::DockingController::getDockDialog | ( |  | ) |

Get docking dialog.

## initializeWidget()

virtual void BALL::VIEW::DockingController::initializeWidget | ( | MainControl & | main_control | ) |

virtual

Initializes the popup menu Molecular Mechanics with its checkable submenu Docking . Calls DockDialog::initializeWidget . It is called automatically immediately before the main application is started.

Parameters

  main_control | the MainControl object to be initialized

See also
  openDialog
  finalizeWidget
  insertMenuEntry

Reimplemented from BALL::VIEW::ModularWidget.

## onNotify()

virtual void BALL::VIEW::DockingController::onNotify | ( | Message * | message | ) |

virtual

Message handling method. Catches DockingFinishedMessage and ShowDockResultMessage .

Parameters

  message | the pointer to the message that should be processed

Reimplemented from BALL::VIEW::ConnectionObject.

## operator=()

const DockingController & BALL::VIEW::DockingController::operator= | ( | const DockingController & | dock_controller | ) |

Assignment operator.

## runDocking()

virtual void BALL::VIEW::DockingController::runDocking | ( | bool | is_redock | ) |

virtual

Shows docking dialog, checks which algorithm is chosen and creates new DockingAlgorithm object. Starts new Thread and fills/shows progress_dialog_ .

Parameters

  is_redock | flag that indicates if a docking or redocking should be run

## runScoring_()

bool BALL::VIEW::DockingController::runScoring_ | ( | ConformationSet * | conformation_set | ) |

protected

Applies scoring function which user has chosen. Then, creates new DockResult and adds new scoring to it. At the end, adds the docked system to BALLView structures and sends a NewDockResultMessage to insert the DockResult in DatasetControl. Is called in onNotify .

Parameters

  conformation_set | conformation set that contains the result of the docking algorithm

Returns
  true if scoring function was succesfully applied
  false if scoring function was not succesfully applied

## startDocking

void BALL::VIEW::DockingController::startDocking | ( |  | ) |

slot

Is called when docking is started by clicking on menu entry Docking . Calls runDocking(false) .

## writePreferences()

virtual void BALL::VIEW::DockingController::writePreferences | ( | INIFile & | file | ) |

virtual

Writes the preferences to the INIFile. Calls DockDialog::writePreferences . This method will be called inside the method MainControl::aboutToExit .

See also
  fetchPreferences

Reimplemented from BALL::VIEW::ModularWidget.